ball = {};


ball = {
	gfx = "gfx/ball.png",
	friction = 0.2,
	kickspeed = 10,
	kickrotspeed = 10,
	xstart = (30 * 32) + 16,
	ystart = (23 * 32) + 16,
	rot = 0,
	rotspeed = 0,
	x = 0,
	y = 0,
	lastx = 0,
	lasty = 0,
	mx = 0,
	my = 0,
	xtile = 0,
	ytile = 0,
	img = 0,
}

points = {
	ct = 0;
	t = 0;
}


function points_hud()
	parse('hudtxt 0 "255000000[ T ] points : '..points.t..'" 5 380 0')
	parse('hudtxt 1 "000000255[CT] points : '..points.ct..'" 5 400 0')
	parse('hudtxt 2 "[by mafia_man]" 5 420 0')
end

points_hud();

function ball_restart()
	ball.x = ball.xstart;
	ball.y = ball.ystart;
	ball.mx = 0.0;
	ball.my = 0.0;
	ball.lastx = ball.xstart;
	ball.lasty = ball.ystart;
	ball.xtile = 0;
	ball.ytile = 0;
end

function points_restart()
	ball_restart();
	points.ct = 0;
	points.t = 0;
end

ball_restart();
ball.img = image(ball.gfx, ball.xstart, ball.ystart, 0);

function player_attack(id)
	local x, y, dist, dir;
	x = player(id, "x");
	y = player(id, "y");
	
	dist = math.sqrt((ball.x - x)^2 + (ball.y - y)^2);
	if dist <= 40 then
		dir = math.deg(math.atan2(ball.x - x, ball.y - y));
		ball.mx = math.sin(math.rad(dir)) * ball.kickspeed;
		ball.my = math.cos(math.rad(dir)) * ball.kickspeed;
		ball.rotspeed = ball.kickrotspeed;
	end
end

function ball_update()
		-- Add position
		ball.x = ball.x + ball.mx;
		ball.y = ball.y + ball.my;
		
		ball.rot = ball.rot + ball.rotspeed;
		if ball.rotspeed > 0 then
			ball.rotspeed = ball.rotspeed - ball.friction;
		end
		if ball.rotspeed < 0 then
			ball.rotspeed = 0;
		end
		
		if ball.rot > 360 then
			ball.rot = 0
		end
		
		ball.xtile = math.floor(ball.x / 32);
		ball.ytile = math.floor(ball.y / 32);
		
		if (tile(ball.xtile, ball.ytile, "wall") == true) or (tile(ball.xtile, ball.ytile, "obstacle") == true) then
			local dirx, diry;
			local x1, y1, x2, y2;
			
			ball.x = ball.lastx;
			ball.y = ball.lasty;
			
			x2, y2 = ball.xtile, ball.ytile; -- WALL
			ball.xtile = math.floor(ball.x / 32);
			ball.ytile = math.floor(ball.y / 32);
			x1, y1 = ball.xtile, ball.ytile; -- FLOOR

			if x2 == x1 then
				dirx = 0;
			else
				dirx = 1;
			end
			
			if y2 == y1 then
				diry = 0;
			else
				diry = 1;
			end
			
			if dirx == 1 then 
				ball.mx = -ball.mx;
			end
			
			if diry == 1 then
				ball.my = -ball.my;
			end
			
			ball.x = ball.x + ball.mx;
			ball.y = ball.y + ball.my;
		end
		
		ball.xtile = math.floor(ball.x / 32);
		ball.ytile = math.floor(ball.y / 32);
		
		-- Friction X
		if ball.mx > 0 then -- Positive MX
			ball.mx = ball.mx - ball.friction;
			if ball.mx < 0 then
				ball.mx = 0
			end
		elseif ball.mx < 0 then -- Negative MX
			ball.mx = ball.mx + ball.friction;
			if ball.mx > 0 then
				ball.mx = 0
			end
		end
		
		-- Friction Y
		if ball.my > 0 then -- Positive MY
			ball.my = ball.my - ball.friction;
			if ball.my < 0 then
				ball.my = 0
			end
		elseif ball.my < 0 then -- Negative MY
			ball.my = ball.my + ball.friction;
			if ball.my > 0 then
				ball.my = 0
			end
		end
		
		-- Update Image
		if ball.xtile >= 0 and ball.ytile >= 0 and ball.xtile < map("xsize") and ball.ytile < map("ysize") then
			imagepos(ball.img, ball.x, ball.y, ball.rot);
		else
			ball.x = ball.lastx;
			ball.y = ball.lasty;
			ball.mx = -ball.mx;
			ball.my = -ball.my;
			ball.xtile = math.floor(ball.x / 32);
			ball.ytile = math.floor(ball.y / 32);
			imagepos(ball.img, ball.x, ball.y, ball.rot);
		end
		
		ball.lastx = ball.x;
		ball.lasty = ball.y;
		
		if entity(ball.xtile, ball.ytile, "name") == "twin" then
			points.t = points.t + 1;
			ball_restart();
			points_hud();
		end
		if entity(ball.xtile, ball.ytile, "name") == "ctwin" then
			points.ct = points.ct + 1;
			ball_restart();
			points_hud();
		end
end

function player_hit(id, source)
	if source > 0 then
		return 1
	end
end

addhook("hit", "player_hit");
addhook("always", "ball_update");
addhook("attack", "player_attack");
addhook("spawn", "points_hud");